## copyq 6.0.1

=== CMakeLists.txt ===
project(copyq)

if (APPLE)
    cmake_minimum_required(VERSION 3.1)
    set(COPYQ_EXECUTABLE_NAME "CopyQ")
else()
    cmake_minimum_required(VERSION 2.8.12)
    set(COPYQ_EXECUTABLE_NAME ${PROJECT_NAME})
endif()

# C++17
if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} GREATER 3.1)
    set(CMAKE_CXX_STANDARD 17)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
endif()

if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(COPYQ_DEBUG ON)
    add_definitions( -DCOPYQ_DEBUG  )
endif()

OPTION(PEDANTIC "Enable all compiler warnings" OFF)

# Options (cmake -LH)
OPTION(WITH_TESTS "Run test cases from command line" ${COPYQ_DEBUG})
OPTION(WITH_PLUGINS "Compile plugins" ON)

# Unix-specific options
if (UNIX AND NOT APPLE)
    include(GNUInstallDirs)
    set(DATA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}" CACHE PATH "Install path for data")
    set(PLUGIN_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/${CMAKE_SHARED_MODULE_PREFIX}/copyq/plugins" CACHE PATH "Install path for plugins")
    set(ICON_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/icons/hicolor/scalable/apps" CACHE PATH "Install path for icons")
    set(ICON_INSTALL_PREFIX_TEMPLATE "${DATA_INSTALL_PREFIX}/icons/hicolor/%SIZE%/apps" CACHE PATH "Install path for icons (%SIZE% is icon size)")
    set(THEME_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/copyq/themes" CACHE PATH "Install path for themes")
    set(DESKTOP_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/applications" CACHE PATH "Install path for desktop file")
    set(APPDATA_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/metainfo" CACHE PATH "Install path for AppData file")
    set(MANPAGE_INSTALL_PREFIX "${CMAKE_INSTALL_MANDIR}/man1" CACHE PATH "Install path for manual pages")
    set(TRANSLATION_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/copyq/translations" CACHE PATH "Install path for translations")
    set(BASH_COMPLETION_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/bash-completion/completions/" CACHE PATH "Install path for bash completions")
    set(ICON_NAME "copyq" CACHE STRING "Name for icon files")
    set(COPYQ_AUTOSTART_COMMAND "" CACHE STRING "Autostart command")
endif()

set(CMAKE_AUTOMOC ON)

OPTION(WITH_QT6 "Enable Qt 6" OFF)
if (WITH_QT6)
    set(QT_DEFAULT_MAJOR_VERSION 6)
    find_package(Qt6Widgets 6.1.0 REQUIRED)
    set(copyq_qt Qt6)
    add_definitions( -DQT_DEPRECATED_WARNINGS_SINCE=0x051500 )
else()
    set(QT_DEFAULT_MAJOR_VERSION 5)
    find_package(Qt5Widgets 5.8.0 REQUIRED)
    set(copyq_qt Qt5)
    if (Qt5Widgets_VERSION VERSION_LESS 5.15.0)
        function(qt_wrap_ui outfiles)
            qt5_wrap_ui("${outfiles}" ${ARGN})
            set("${outfiles}" "${${outfiles}}" PARENT_SCOPE)
        endfunction()
        function(qt_add_resources outfiles)
            qt5_add_resources("${outfiles}" ${ARGN})
            set("${outfiles}" "${${outfiles}}" PARENT_SCOPE)
        endfunction()
        function(qt_add_translation _qm_files)
            qt5_add_translation("${_qm_files}" ${ARGN})
            set("${_qm_files}" "${${_qm_files}}" PARENT_SCOPE)
        endfunction()
    endif()
endif()

list(APPEND copyq_LIBRARIES ${copyq_qt}::Widgets)

set(copyq_APP_ID          com.github.hluk.copyq)
set(copyq_ICON_PREFIX     src/images/icon)
set(copyq_ICON_NORMAL     src/images/icon.svg)
set(copyq_ICON_MASK       src/images/icon_mask.svg)
set(copyq_DESKTOP         shared/${copyq_APP_ID}.desktop)
set(copyq_APPDATA         shared/${copyq_APP_ID}.appdata.xml)
set(copyq_BASH_COMPLETION shared/copyq-completion)
set(copyq_MANPAGE         debian/copyq.1)

# Be more strict while compiling debugging version
if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-long-long")
    set(CMAKE_CXX_FLAGS_DEBUG
        "${CMAKE_CXX_FLAGS_DEBUG} -Wextra -Wall -pedantic -Wfloat-equal -Woverloaded-virtual -Wundef -Wno-inconsistent-missing-destructor-override")
endif()

if (PEDANTIC)
    if (CMAKE_COMPILER_IS_GNUCXX)
        list(APPEND copyq_pedantic_flags
            -Wextra -Wall
            -Wsuggest-override
            -Wlogical-op
            -Wnoexcept
            -Wstrict-null-sentinel
            )
    else()
        list(APPEND copyq_pedantic_flags
            -Weverything
            -Winconsistent-missing-override
            )

        list(APPEND copyq_pedantic_flags
            -Wno-c++98-compat
            -Wno-c++98-compat-pedantic
            -Wno-disabled-macro-expansion
            -Wno-double-promotion
            -Wno-exit-time-destructors
            -Wno-extra-semi-stmt
            -Wno-redundant-parens
            -Wno-shadow-field
            -Wno-shadow-field-in-constructor
            -Wno-shorten-64-to-32
            -Wno-sign-conversion
            -Wno-suggest-destructor-override
            -Wno-unknown-warning-option
            -Wno-used-but-marked-unused
            -Wno-weak-vtables
            -fcomment-block-commands=retval
            )
    endif()

    list(APPEND copyq_pedantic_flags
        -pedantic
        -Wcast-align
        -Wctor-dtor-privacy
        -Wdisabled-optimization
        -Wformat=2
        -Winit-self
        -Wmissing-declarations
        -Wmissing-include-dirs
        -Wold-style-cast
        -Woverloaded-virtual
        -Wredundant-decls
        -Wstrict-overflow=4
        -Wundef
        )

    list(APPEND copyq_pedantic_flags
        -Wno-padded
        -Wno-switch-enum
        )

    # Disable Q_OBJECT macro warnings.
    list(APPEND copyq_pedantic_flags
        -Wno-unused-member-function
        )
endif()

if(WITH_TESTS)
    message(STATUS "Building with tests.")

    add_definitions( -DHAS_TESTS )

    find_package(${copyq_qt}Test REQUIRED)
    list(APPEND copyq_LIBRARIES ${copyq_qt}::Test)
endif()

include(src/version.cmake)
message(STATUS "Building CopyQ version ${copyq_version}.")

if (UNIX AND NOT APPLE)
    install(FILES ${copyq_ICON_NORMAL}     DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}.svg)
    install(FILES ${copyq_ICON_MASK}       DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}_mask.svg)
    install(FILES ${copyq_APPDATA}         DESTINATION ${APPDATA_INSTALL_PREFIX})
    install(FILES ${copyq_MANPAGE}         DESTINATION ${MANPAGE_INSTALL_PREFIX})
    install(FILES ${copyq_BASH_COMPLETION} DESTINATION ${BASH_COMPLETION_INSTALL_PREFIX} RENAME copyq)

    configure_file(${copyq_DESKTOP}.in ${copyq_DESKTOP})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${copyq_DESKTOP} DESTINATION ${DESKTOP_INSTALL_PREFIX})

    foreach (copyq_ICON_EXTENT 16 22 24 32 48 64 128)
        set(copyq_ICON_SIZE "${copyq_ICON_EXTENT}x${copyq_ICON_EXTENT}")
        string(REPLACE "%SIZE%" "${copyq_ICON_SIZE}" copyq_ICON_TARGET_PREFIX "${ICON_INSTALL_PREFIX_TEMPLATE}")
        foreach (copyq_ICON_TYPE "")
            install(FILES "${copyq_ICON_PREFIX}${copyq_ICON_TYPE}_${copyq_ICON_SIZE}.png" DESTINATION "${copyq_ICON_TARGET_PREFIX}" RENAME "${ICON_NAME}${copyq_ICON_TYPE}.png")
        endforeach()
    endforeach()

    set(copyq_THEME_INSTALL_PREFIX ${THEME_INSTALL_PREFIX})
    file(GLOB copyq_THEMES shared/themes/*.css shared/themes/*.ini)
    install(FILES ${copyq_THEMES} DESTINATION ${THEME_INSTALL_PREFIX})

    add_definitions( -DCOPYQ_ICON_PREFIX="${ICON_INSTALL_PREFIX}/${ICON_NAME}" )
    add_definitions( -DCOPYQ_THEME_PREFIX="${THEME_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_PLUGIN_PREFIX="${PLUGIN_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_DESKTOP_FILE="${DESKTOP_INSTALL_PREFIX}/${copyq_APP_ID}.desktop" )
    add_definitions( -DCOPYQ_TRANSLATION_PREFIX="${TRANSLATION_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_BASH_COMPLETION_PREFIX="${BASH_COMPLETION_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_ICON_NAME="${ICON_NAME}" )

    if (COPYQ_AUTOSTART_COMMAND)
        add_definitions( -DCOPYQ_AUTOSTART_COMMAND="${COPYQ_AUTOSTART_COMMAND}" )
    endif()
elseif (APPLE)
    set(copyq_themes_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/Resources/themes")
    file(GLOB copyq_THEMES shared/themes/*.css shared/themes/*.ini)
    install(FILES ${copyq_THEMES} DESTINATION "${copyq_themes_dest_dir}" COMPONENT Runtime)
endif()

if (MSVC)
    include(InstallRequiredSystemLibraries)
endif()

add_definitions( -DQT_NO_CAST_TO_ASCII )

set_property(GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)

if (WITH_PLUGINS)
    add_subdirectory(plugins)
endif()

add_subdirectory(src)

=== plugins/itemfakevim/CMakeLists.txt ===
file(GLOB copyq_plugin_itemfakevim_SOURCES
    ../../src/item/itemwidgetwrapper.cpp
    )
file(GLOB copyq_plugin_itemfakevim_external_SOURCES
    fakevim/*.cpp
    fakevim/utils/*.cpp
    )

set(copyq_plugin_itemfakevim_DEFINITIONS
    QT_NO_CAST_TO_ASCII
    QT_RESTRICTED_CAST_FROM_ASCII
    QTCREATOR_UTILS_STATIC_LIB)

set(copyq_plugin_itemfakevim_RESOURCES itemfakevim.qrc)

copyq_add_plugin(itemfakevim)
target_include_directories(itemfakevim SYSTEM PRIVATE fakevim)

=== plugins/itempinned/CMakeLists.txt ===
set(copyq_plugin_itempinned_SOURCES
    ../../src/item/itemwidgetwrapper.cpp
    ../../src/item/itemsaverwrapper.cpp
    ../../src/common/display.cpp
    ../../src/gui/screen.cpp
    )

copyq_add_plugin(itempinned)

=== debian/changelog ===
copyq (6.0.1-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 23 Feb 2022 15:33:28 -0800

copyq (6.0.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Sun, 06 Feb 2022 17:44:28 -0500

copyq (6.0.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Set myself as package maintainer.

 -- Boyuan Yang <byang@debian.org>  Fri, 07 Jan 2022 21:39:31 -0500

copyq (5.0.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Sat, 06 Nov 2021 19:02:10 -0400

copyq (4.1.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Fri, 20 Aug 2021 11:20:14 -0400

=== debian/control ===
Source: copyq
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends: cmake, debhelper-compat (= 12), extra-cmake-modules
Build-Depends-Arch: libkf5notifications-dev,
                    libqt5svg5-dev,
                    libqt5waylandclient5-dev,
                    libqt5x11extras5-dev,
                    libwayland-dev,
                    libxfixes-dev,
                    libxtst-dev,
                    qtbase5-private-dev,
                    qtdeclarative5-dev,
                    qttools5-dev,
                    qttools5-dev-tools,
                    qtwayland5,
                    qtwayland5-dev-tools
Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme, python3:any
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://hluk.github.io/CopyQ/
Vcs-Browser: https://salsa.debian.org/debian/copyq
Vcs-Git: https://salsa.debian.org/debian/copyq.git

Package: copyq
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
         copyq-plugins (= ${binary:Version}), libqt5svg5
Suggests: copyq-doc
Description: Advanced clipboard manager with editing and scripting features
 CopyQ monitors system clipboard and saves its content in customized tabs.
 Saved clipboard can be later copied and pasted directly into any application.
 .
 Items can be:
  * edited with internal editor or with preferred text editor,
  * moved to other tabs,
  * drag'n'dropped to applications,
  * marked with tag or a note,
  * passed to or changed by custom commands,
  * or simply removed.
 .
 Features:
  * Support for Linux, Windows and OS X 10.9+
  * Store text, HTML, images or any other custom formats
  * Quickly browse and filter items in clipboard history
  * Sort, create, edit, remove, copy/paste, drag'n'drop items in tabs
  * Add notes or tags to items
  * System-wide shortcuts with customizable commands
  * Paste items with shortcut or from tray or main window
  * Fully customizable appearance
  * Advanced command-line interface and scripting
  * Ignore clipboard copied from some windows or containing some text
  * Support for simple Vim-like editor and shortcuts
  * Many more features

Package: copyq-doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Section: doc
Multi-Arch: foreign
Description: Documentation and examples for CopyQ - HTML format
 CopyQ monitors system clipboard and saves its content in customized tabs.
 Saved clipboard can be later copied and pasted directly into any application.
 .
 This contains the documentation in HTML format.

Package: copyq-plugins
Architecture: any
Depends: copyq (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Plugins for CopyQ
 CopyQ monitors system clipboard and saves its content in customized tabs.
 Saved clipboard can be later copied and pasted directly into any application.
 .
 This package contains plugins that add various item types support and features
 to CopyQ, including:
  * Text with Highlighting
  * Images
  * Web Pages
  * Various Data
  * Notes
  * Encryption
  * FakeVim Editor
  * Synchronize Items to Disk
  * Item Tags
  * Pinned Items

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

export QT_SELECT := 5


%:
	dh $@ --with sphinxdoc

%-arch:
	dh $@

%-indep:
	dh $@ --with sphinxdoc

clean:
	dh $@

override_dh_auto_clean-indep:
	rm -rf _build/

override_dh_auto_configure-indep:

override_dh_auto_build-indep: _build/html/

_build/html/: docs/conf.py $(wildcard docs/*.rst docs/images/*)
	python3 -m sphinx docs/ $@

override_dh_auto_install-indep:

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## copyq 6.1.0

=== debian/changelog ===
copyq (6.1.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 18 Apr 2022 16:29:58 -0700

copyq (6.1.0-1) unstable; urgency=medium

  * New upstream release. 

 -- Boyuan Yang <byang@debian.org>  Sun, 13 Mar 2022 11:45:21 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
-Build-Depends: cmake, debhelper-compat (= 12), extra-cmake-modules
+Build-Depends: cmake, debhelper-compat (= 13), extra-cmake-modules
 Build-Depends-Arch: libkf5notifications-dev,
                     libqt5svg5-dev,
                     libqt5waylandclient5-dev,
@@ -26,7 +26,7 @@
 
 Package: copyq
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}, 
          copyq-plugins (= ${binary:Version}), libqt5svg5
 Suggests: copyq-doc
 Description: Advanced clipboard manager with editing and scripting features

## copyq 6.2.0

=== debian/changelog ===
copyq (6.2.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 27 Jul 2022 17:23:34 -0400

copyq (6.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 08 Jul 2022 21:24:46 -0400

copyq (6.1.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Sat, 19 Mar 2022 08:35:02 -0400

## copyq 6.3.0

=== plugins/itemfakevim/CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,11 @@
     )
 file(GLOB copyq_plugin_itemfakevim_external_SOURCES
     fakevim/*.cpp
-    fakevim/utils/*.cpp
     )
 
 set(copyq_plugin_itemfakevim_DEFINITIONS
     QT_NO_CAST_TO_ASCII
-    QT_RESTRICTED_CAST_FROM_ASCII
-    QTCREATOR_UTILS_STATIC_LIB)
+    QT_RESTRICTED_CAST_FROM_ASCII)
 
 set(copyq_plugin_itemfakevim_RESOURCES itemfakevim.qrc)

=== debian/changelog ===
copyq (6.3.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Tue, 27 Sep 2022 13:13:56 -0400

copyq (6.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 20 Sep 2022 13:34:50 -0400

## copyq 6.3.2

=== docs/requirements.txt ===
alabaster==0.7.12
Babel==2.9.1
certifi==2021.10.8
charset-normalizer==2.0.7
docutils==0.17.1
idna==3.3
imagesize==1.2.0
Jinja2==3.0.2
MarkupSafe==2.0.1
packaging==21.2
Pygments==2.10.0
pyparsing==2.4.7
pytz==2021.3
requests==2.26.0
snowballstemmer==2.1.0
Sphinx==4.2.0
sphinx-rtd-theme==1.0.0
sphinxcontrib-applehelp==1.0.2
sphinxcontrib-devhelp==1.0.2
sphinxcontrib-htmlhelp==2.0.0
sphinxcontrib-jsmath==1.0.1
sphinxcontrib-qthelp==1.0.3
sphinxcontrib-serializinghtml==1.1.5
urllib3==1.26.7

=== src/CMakeLists.txt ===
# Project files
file(GLOB copyq_SOURCES
    main.cpp
    app/*.cpp
    common/*.cpp
    gui/*.cpp
    gui/notification.h
    item/*.cpp
    scriptable/*.cpp
    scriptable/scriptableproxy.h
    )

file(GLOB copyq_FORMS
    ui/*.ui
    )

set(copyq_RESOURCES copyq.qrc)

# Qt include paths and definitions
include_directories(${CMAKE_CURRENT_BINARY_DIR} .)
include_directories(${${copyq_qt}Widgets_INCLUDES})
add_definitions(${${copyq_qt}Widgets_DEFINITIONS})

include(notifications.cmake)
include(platform/platform.cmake)

# Compile with tests?
if (WITH_TESTS)
    file(GLOB copyq_SOURCES ${copyq_SOURCES} tests/*.cpp)
endif()

set_source_files_properties(
    ${copyq_SOURCES} PROPERTIES
    COMPILE_OPTIONS "${copyq_pedantic_flags}")

# Qxt - global shortcuts
if (USE_QXT)
    set(copyq_SOURCES ${copyq_SOURCES}
        ../qxt/qxtglobalshortcut.cpp
        )
    add_definitions( -DQXT_STATIC )
endif()

# translations
file(GLOB copyq_TRANSLATIONS ../translations/*.ts)

find_package(${copyq_qt}LinguistTools)
if (${copyq_qt}LinguistTools_FOUND)
    qt_add_translation(copyq_QM ${copyq_TRANSLATIONS})
endif()

qt_wrap_ui(copyq_FORMS_HEADERS ${copyq_FORMS})
qt_add_resources(copyq_RESOURCES_RCC ${copyq_RESOURCES})

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})

# Generate version.h from current git commit if available.
set(copyq_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/common/version.cpp")
add_custom_target(
    generate_version_file
    ALL
    COMMAND ${CMAKE_COMMAND}
        -D INPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/common/version.cpp.in
        -D OUTPUT_FILE=${copyq_VERSION_FILE}
        -P ${CMAKE_CURRENT_SOURCE_DIR}/version_file.cmake
    BYPRODUCTS ${copyq_VERSION_FILE}
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
)
set_source_files_properties(${copyq_VERSION_FILE} PROPERTIES GENERATED TRUE)
set_property(SOURCE ${copyq_VERSION_FILE} PROPERTY SKIP_AUTOMOC ON)

set(copyq_COMPILE
    ${copyq_COMPILE}
    ${copyq_SOURCES}
    ${copyq_FORMS_HEADERS}
    ${copyq_RESOURCES_RCC}
    ${copyq_QM}
    ${copyq_VERSION_FILE}
    )

if (NOT copyq_version)
    message(FATAL_ERROR "Application version is unset")
endif()

if (NOT APPLE)
    add_executable(${COPYQ_EXECUTABLE_NAME} ${copyq_COMPILE})
else()
    # On Macs we must ensure Carbon and Cocoa are linked
    FIND_LIBRARY(CARBON_LIBRARY "Carbon")
    FIND_LIBRARY(COCOA_LIBRARY "Cocoa")
    MARK_AS_ADVANCED (CARBON_LIBRARY
        COCOA_LIBRARY)
    list(APPEND copyq_LIBRARIES "${CARBON_LIBRARY}" "${COCOA_LIBRARY}")

    set(COPYQ_VERSION_REGEX "^([0-9]+)\.([0-9]+)\.(.*)$")
    string(REGEX REPLACE "${COPYQ_VERSION_REGEX}"
        "\\1" CPACK_PACKAGE_VERSION_MAJOR
        "${copyq_version}"
        )
    string(REGEX REPLACE "${COPYQ_VERSION_REGEX}"
        "\\2" CPACK_PACKAGE_VERSION_MINOR
        "${copyq_version}"
        )
    string(REGEX REPLACE "${COPYQ_VERSION_REGEX}"
        "\\3" CPACK_PACKAGE_VERSION_PATCH
        "${copyq_version}"
        )

    set(MACOSX_BUNDLE_BUNDLE_NAME "${COPYQ_EXECUTABLE_NAME}")
    set(MACOSX_BUNDLE_GUI_IDENTIFIER "io.github.hluk.CopyQ")
    set(MACOSX_BUNDLE_INFO_STRING "Advanced clipboard manager with editing and scripting features")
    set(MACOSX_BUNDLE_ICON_FILE "icon.icns")
    set(MACOSX_BUNDLE_LONG_VERSION_STRING "${copyq_version}")
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
    set(MACOSX_BUNDLE_BUNDLE_VERSION "${copyq_version}")

    set_source_files_properties("${CMAKE_CURRENT_SOURCE_DIR}/images/icon.icns" PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    set(copyq_COMPILE ${copyq_COMPILE} "${CMAKE_CURRENT_SOURCE_DIR}/images/icon.icns")

    add_executable(${COPYQ_EXECUTABLE_NAME} MACOSX_BUNDLE ${copyq_COMPILE})
endif()

target_sources(${COPYQ_EXECUTABLE_NAME} PRIVATE ${copyq_SOURCES})
add_dependencies(${COPYQ_EXECUTABLE_NAME} generate_version_file)

# Qt modules
list(APPEND copyq_qt_modules Network Svg Xml Qml)
foreach (copyq_qt_module ${copyq_qt_modules})
    find_package(${copyq_qt}${copyq_qt_module} REQUIRED)
    list(APPEND copyq_LIBRARIES ${copyq_qt}::${copyq_qt_module})
endforeach()

# macros definitions for preprocessor and moc
set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES COMPILE_DEFINITIONS "${copyq_DEFINITIONS}")

# link
set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES LINK_FLAGS "${copyq_LINK_FLAGS}")
target_link_libraries(${COPYQ_EXECUTABLE_NAME} ${copyq_LIBRARIES})

# install
if (WIN32)
    install(TARGETS ${COPYQ_EXECUTABLE_NAME}
        RUNTIME DESTINATION . COMPONENT Runtime
        LIBRARY DESTINATION . COMPONENT Runtime
        )
else()
    install(TARGETS ${COPYQ_EXECUTABLE_NAME}
        BUNDLE DESTINATION . COMPONENT Runtime
        RUNTIME DESTINATION bin COMPONENT Runtime
        )
endif()

if (NOT APPLE)
    if (TRANSLATION_INSTALL_PREFIX)
        install(FILES ${copyq_QM} DESTINATION "${TRANSLATION_INSTALL_PREFIX}")
    endif()
else()
    set_source_files_properties(${copyq_QM} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/translations")

    set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/../shared/Info.plist")

    set(plugin_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/PlugIns")
    set(qtconf_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/Resources")

    macro(install_qt_plugin _qt_plugin_name _qt_plugins_var)
        get_target_property(_qt_plugin_path "${_qt_plugin_name}" LOCATION)
        if(EXISTS "${_qt_plugin_path}")
            get_filename_component(_qt_plugin_file "${_qt_plugin_path}" NAME)
            get_filename_component(_qt_plugin_type "${_qt_plugin_path}" PATH)
            get_filename_component(_qt_plugin_type "${_qt_plugin_type}" NAME)
            set(_qt_plugin_dest "${plugin_dest_dir}/${_qt_plugin_type}")
            install(FILES "${_qt_plugin_path}" DESTINATION "${_qt_plugin_dest}" COMPONENT Runtime)
            set(${_qt_plugins_var}
                "${${_qt_plugins_var}};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_qt_plugin_dest}/${_qt_plugin_file}")
        else()
            message(FATAL_ERROR "QT plugin ${_qt_plugin_name} not found")
        endif()
    endmacro()

    # Install needed Qt plugins
    foreach(_copyq_qt_module ${copyq_qt_modules} "Gui" "Widgets")
        set(_module_plugins "${${copyq_qt}${_copyq_qt_module}_PLUGINS}")
        foreach(_plugin ${_module_plugins})
            install_qt_plugin("${_plugin}" FIXUP_BUNDLE_QT_PLUGINS)
        endforeach()
    endforeach()

    # install a qt.conf file
    # this inserts some cmake code into the install script to write the file
    install(CODE "
        file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${qtconf_dest_dir}/qt.conf\" \"[Paths]\nPlugins = PlugIns\nImports = Resources/qml\nQml2Imports = Resources/qml\n\")
        "
        COMPONENT Runtime
        )

    set(FIXUP_BUNDLE_APPS "\${CMAKE_INSTALL_PREFIX}/${COPYQ_EXECUTABLE_NAME}.app")

    get_property(_copyq_installed_plugins GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)

    # Directories to look for dependencies
    set(FIXUP_BUNDLE_DEP_DIRS "${CMAKE_BINARY_DIR};${QT_LIBRARY_DIRS};${${copyq_qt}Widgets_DIR}/../..")

    message(STATUS "Fixup app: ${FIXUP_BUNDLE_APPS}")
    message(STATUS "Fixup app plugins: ${_copyq_installed_plugins}")
    message(STATUS "Fixup qt plugins: ${FIXUP_BUNDLE_QT_PLUGINS}")
    message(STATUS "Fixup dirs: ${FIXUP_BUNDLE_DEP_DIRS}")
    install(CODE "
        include(BundleUtilities)
        set(BU_CHMOD_BUNDLE_ITEMS ON)
        fixup_bundle(\"${FIXUP_BUNDLE_APPS}\" \"${FIXUP_BUNDLE_QT_PLUGINS};${_copyq_installed_plugins}\" \"${FIXUP_BUNDLE_DEP_DIRS}\")
        verify_app(\"${FIXUP_BUNDLE_APPS}\")
        "
        COMPONENT Runtime
        )

    set(CPACK_GENERATOR "DragNDrop")
    include(CPack)
endif()

=== plugins/itemtags/CMakeLists.txt ===
set(copyq_plugin_itemtags_SOURCES
    ../../src/item/itemwidgetwrapper.cpp
    ../../src/item/itemsaverwrapper.cpp
    ../../src/common/config.cpp
    ../../src/common/log.cpp
    ../../src/common/mimetypes.cpp
    ../../src/common/textdata.cpp
    ../../src/gui/iconselectbutton.cpp
    ../../src/gui/iconselectdialog.cpp
    ../../src/gui/iconwidget.cpp
    ../../src/gui/iconfont.cpp
    ../../src/gui/screen.cpp
    )

copyq_add_plugin(itemtags)

=== src/platform/x11/systemclipboard/CMakeLists.txt ===
find_package(QtWaylandScanner REQUIRED)
include_directories(SYSTEM ${${copyq_qt}Gui_PRIVATE_INCLUDE_DIRS}) # for native interface to get wl_seat
find_package(Wayland 1.15 COMPONENTS Client)
find_package(${copyq_qt} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS WaylandClient)

set(systemclipboard_SRCS
    waylandclipboard.cpp
)

ecm_add_qtwayland_client_protocol(systemclipboard_SRCS
    PROTOCOL  wlr-data-control-unstable-v1.xml
    BASENAME wlr-data-control-unstable-v1
)

add_library(systemclipboard STATIC ${systemclipboard_SRCS})
target_link_libraries(systemclipboard
                      ${copyq_qt}::Gui
                      ${copyq_qt}::WaylandClient
                      Wayland::Client
)

=== debian/changelog ===
copyq (6.3.2-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 02 Nov 2022 17:11:37 -0700

copyq (6.3.2-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 26 Oct 2022 16:15:27 -0400

copyq (6.3.2-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Oct 2022 11:55:22 -0400

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 Package: copyq
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, 
+Depends: ${misc:Depends}, ${shlibs:Depends},
          copyq-plugins (= ${binary:Version}), libqt5svg5
 Suggests: copyq-doc
 Description: Advanced clipboard manager with editing and scripting features

## copyq 6.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,8 @@
 # Options (cmake -LH)
 OPTION(WITH_TESTS "Run test cases from command line" ${COPYQ_DEBUG})
 OPTION(WITH_PLUGINS "Compile plugins" ON)
+
+add_definitions( -DQT_USE_STRINGBUILDER  )
 
 # Unix-specific options
 if (UNIX AND NOT APPLE)

=== docs/requirements.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 alabaster==0.7.12
 Babel==2.9.1
-certifi==2021.10.8
+certifi==2022.12.7
 charset-normalizer==2.0.7
 docutils==0.17.1
 idna==3.3

=== plugins/itemnotes/CMakeLists.txt ===
set(copyq_plugin_itemnotes_SOURCES
    ../../src/item/itemwidgetwrapper.cpp
    ../../src/gui/iconfont.cpp
    ../../src/gui/iconwidget.cpp
    ../../src/common/mimetypes.cpp
    ../../src/common/textdata.cpp
    )

copyq_add_plugin(itemnotes)

=== debian/changelog ===
copyq (6.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 20 Jan 2023 10:25:23 -0500

=== debian/control ===
--- 
+++ 
@@ -1,34 +1,45 @@
 Source: copyq
 Section: utils
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
-Build-Depends: cmake, debhelper-compat (= 13), extra-cmake-modules
-Build-Depends-Arch: libkf5notifications-dev,
-                    libqt5svg5-dev,
-                    libqt5waylandclient5-dev,
-                    libqt5x11extras5-dev,
-                    libwayland-dev,
-                    libxfixes-dev,
-                    libxtst-dev,
-                    qtbase5-private-dev,
-                    qtdeclarative5-dev,
-                    qttools5-dev,
-                    qttools5-dev-tools,
-                    qtwayland5,
-                    qtwayland5-dev-tools
-Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme, python3:any
+Maintainer: Boyuan Yang <byang@debian.org>
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ extra-cmake-modules,
+Build-Depends-Arch:
+ libkf5notifications-dev,
+ libqt5svg5-dev,
+ libqt5waylandclient5-dev,
+ libqt5x11extras5-dev,
+ libwayland-dev,
+ libxfixes-dev,
+ libxtst-dev,
+ qtbase5-private-dev,
+ qtdeclarative5-dev,
+ qttools5-dev,
+ qttools5-dev-tools,
+ qtwayland5,
+ qtwayland5-dev-tools,
+Build-Depends-Indep:
+ python3-sphinx,
+ python3-sphinx-rtd-theme,
+ python3:any,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://hluk.github.io/CopyQ/
 Vcs-Browser: https://salsa.debian.org/debian/copyq
 Vcs-Git: https://salsa.debian.org/debian/copyq.git
 
 Package: copyq
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends},
-         copyq-plugins (= ${binary:Version}), libqt5svg5
-Suggests: copyq-doc
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Recommends:
+ copyq-plugins (= ${binary:Version}),
+ libqt5svg5,
+Suggests:
+ copyq-doc,
 Description: Advanced clipboard manager with editing and scripting features
  CopyQ monitors system clipboard and saves its content in customized tabs.
  Saved clipboard can be later copied and pasted directly into any application.
@@ -57,8 +68,11 @@
 
 Package: copyq-doc
 Architecture: all
-Depends: ${misc:Depends}, ${sphinxdoc:Depends}
-Built-Using: ${sphinxdoc:Built-Using}
+Depends:
+ ${misc:Depends},
+ ${sphinxdoc:Depends},
+Built-Using:
+ ${sphinxdoc:Built-Using},
 Section: doc
 Multi-Arch: foreign
 Description: Documentation and examples for CopyQ - HTML format
@@ -69,7 +83,10 @@
 
 Package: copyq-plugins
 Architecture: any
-Depends: copyq (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ copyq (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Plugins for CopyQ
  CopyQ monitors system clipboard and saves its content in customized tabs.
  Saved clipboard can be later copied and pasted directly into any application.

=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,3 @@
 	python3 -m sphinx docs/ $@
 
 override_dh_auto_install-indep:
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## copyq 7.0.0

=== debian/changelog ===
copyq (7.0.0-0.1~mx21+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 10 May 2023 16:05:12 -0700

copyq (6.4.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 22 Feb 2023 14:05:42 -0800

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,23 @@
 Source: copyq
 Section: utils
 Priority: optional
-Maintainer: Boyuan Yang <byang@debian.org>
-Build-Depends:
- cmake,
- debhelper-compat (= 13),
- extra-cmake-modules,
-Build-Depends-Arch:
- libkf5notifications-dev,
- libqt5svg5-dev,
- libqt5waylandclient5-dev,
- libqt5x11extras5-dev,
- libwayland-dev,
- libxfixes-dev,
- libxtst-dev,
- qtbase5-private-dev,
- qtdeclarative5-dev,
- qttools5-dev,
- qttools5-dev-tools,
- qtwayland5,
- qtwayland5-dev-tools,
-Build-Depends-Indep:
- python3-sphinx,
- python3-sphinx-rtd-theme,
- python3:any,
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
+Build-Depends: cmake, debhelper-compat (= 13), extra-cmake-modules
+Build-Depends-Arch: libkf5notifications-dev,
+                    libqt5svg5-dev,
+                    libqt5waylandclient5-dev,
+                    libqt5x11extras5-dev,
+                    libwayland-dev,
+                    libxfixes-dev,
+                    libxtst-dev,
+                    qtbase5-private-dev,
+                    qtdeclarative5-dev,
+                    qttools5-dev,
+                    qttools5-dev-tools,
+                    qtwayland5,
+                    qtwayland5-dev-tools
+Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme, python3:any
 Rules-Requires-Root: no
 Standards-Version: 4.6.2
 Homepage: https://hluk.github.io/CopyQ/
@@ -32,14 +26,11 @@
 
 Package: copyq
 Architecture: any
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
-Recommends:
- copyq-plugins (= ${binary:Version}),
- libqt5svg5,
-Suggests:
- copyq-doc,
+Depends: copyq-plugins (= ${binary:Version}),
+         libqt5svg5,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: copyq-doc
 Description: Advanced clipboard manager with editing and scripting features
  CopyQ monitors system clipboard and saves its content in customized tabs.
  Saved clipboard can be later copied and pasted directly into any application.
@@ -68,11 +59,8 @@
 
 Package: copyq-doc
 Architecture: all
-Depends:
- ${misc:Depends},
- ${sphinxdoc:Depends},
-Built-Using:
- ${sphinxdoc:Built-Using},
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Built-Using: ${sphinxdoc:Built-Using}
 Section: doc
 Multi-Arch: foreign
 Description: Documentation and examples for CopyQ - HTML format
@@ -83,10 +71,7 @@
 
 Package: copyq-plugins
 Architecture: any
-Depends:
- copyq (= ${binary:Version}),
- ${misc:Depends},
- ${shlibs:Depends},
+Depends: copyq (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Plugins for CopyQ
  CopyQ monitors system clipboard and saves its content in customized tabs.
  Saved clipboard can be later copied and pasted directly into any application.

## copyq 7.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,10 @@
+cmake_minimum_required(VERSION 3.13)
 project(copyq)
 
 if (APPLE)
-    cmake_minimum_required(VERSION 3.1)
     set(COPYQ_EXECUTABLE_NAME "CopyQ")
 else()
-    cmake_minimum_required(VERSION 2.8.12)
-    set(COPYQ_EXECUTABLE_NAME ${PROJECT_NAME})
+    set(COPYQ_EXECUTABLE_NAME copyq)
 endif()
 
 # C++17
@@ -99,14 +98,12 @@
             -Wlogical-op
             -Wnoexcept
             -Wstrict-null-sentinel
+            -Wno-unknown-pragmas
             )
     else()
         list(APPEND copyq_pedantic_flags
             -Weverything
             -Winconsistent-missing-override
-            )
-
-        list(APPEND copyq_pedantic_flags
             -Wno-c++98-compat
             -Wno-c++98-compat-pedantic
             -Wno-disabled-macro-expansion

=== docs/requirements.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 alabaster==0.7.12
 Babel==2.9.1
-certifi==2022.12.7
+certifi==2023.7.22
 charset-normalizer==2.0.7
 docutils==0.17.1
 idna==3.3
@@ -8,10 +8,10 @@
 Jinja2==3.0.2
 MarkupSafe==2.0.1
 packaging==21.2
-Pygments==2.10.0
+Pygments==2.15.0
 pyparsing==2.4.7
 pytz==2021.3
-requests==2.26.0
+requests==2.31.0
 snowballstemmer==2.1.0
 Sphinx==4.2.0
 sphinx-rtd-theme==1.0.0

=== plugins/itemimage/CMakeLists.txt ===
set(copyq_plugin_itemimage_SOURCES
    ../../src/common/action.cpp
    ../../src/common/log.cpp
    ../../src/common/mimetypes.cpp
    ../../src/common/temporaryfile.cpp
    ../../src/item/itemeditor.cpp
    ../../src/item/serialize.cpp
    )

copyq_add_plugin(itemimage)

=== plugins/itempinned/CMakeLists.txt ===
set(copyq_plugin_itempinned_SOURCES
    ../../src/item/itemwidgetwrapper.cpp
    ../../src/item/itemsaverwrapper.cpp
    ../../src/common/command.cpp
    ../../src/common/display.cpp
    ../../src/gui/screen.cpp
    )

copyq_add_plugin(itempinned)

=== src/platform/x11/systemclipboard/CMakeLists.txt ===
include_directories(SYSTEM ${${copyq_qt}Gui_PRIVATE_INCLUDE_DIRS}) # for native interface to get wl_seat
find_package(Wayland 1.15 COMPONENTS Client)
find_package(${copyq_qt} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS WaylandClient)

set(systemclipboard_SRCS
    waylandclipboard.cpp
)

if(WITH_QT6)
    add_library(systemclipboard STATIC ${systemclipboard_SRCS})
    qt_generate_wayland_protocol_client_sources(systemclipboard
        FILES
            "${CMAKE_CURRENT_SOURCE_DIR}/wlr-data-control-unstable-v1.xml"
    )
else()
    find_package(QtWaylandScanner REQUIRED)
    ecm_add_qtwayland_client_protocol(systemclipboard_SRCS
        PROTOCOL wlr-data-control-unstable-v1.xml
        BASENAME wlr-data-control-unstable-v1
    )
    add_library(systemclipboard STATIC ${systemclipboard_SRCS})
endif()

target_link_libraries(systemclipboard
                      ${copyq_qt}::Gui
                      ${copyq_qt}::WaylandClient
                      Wayland::Client
)

=== debian/changelog ===
copyq (7.1.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 27 Sep 2023 18:05:04 -0700

copyq (7.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 13 Sep 2023 11:55:05 -0400

copyq (7.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 12 Jun 2023 16:48:00 -0400

=== debian/rules ===
--- 
+++ 
@@ -38,3 +38,7 @@
 	python3 -m sphinx docs/ $@
 
 override_dh_auto_install-indep:
+
+# No dbgsym packages:
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## copyq 8.0.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -39,6 +39,7 @@
         ../qxt/qxtglobalshortcut.cpp
         )
     add_definitions( -DQXT_STATIC )
+    add_definitions( -DCOPYQ_GLOBAL_SHORTCUTS )
 endif()
 
 # translations
@@ -85,11 +86,9 @@
 if (NOT APPLE)
     add_executable(${COPYQ_EXECUTABLE_NAME} ${copyq_COMPILE})
 else()
-    # On Macs we must ensure Carbon and Cocoa are linked
-    FIND_LIBRARY(CARBON_LIBRARY "Carbon")
-    FIND_LIBRARY(COCOA_LIBRARY "Cocoa")
-    MARK_AS_ADVANCED (CARBON_LIBRARY
-        COCOA_LIBRARY)
+    FIND_LIBRARY(CARBON_LIBRARY Carbon REQUIRED)
+    FIND_LIBRARY(COCOA_LIBRARY Cocoa REQUIRED)
+    MARK_AS_ADVANCED(CARBON_LIBRARY COCOA_LIBRARY)
     list(APPEND copyq_LIBRARIES "${CARBON_LIBRARY}" "${COCOA_LIBRARY}")
 
     set(COPYQ_VERSION_REGEX "^([0-9]+)\.([0-9]+)\.(.*)$")
@@ -157,62 +156,21 @@
 else()
     set_source_files_properties(${copyq_QM} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/translations")
 
+    set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES MACOSX_BUNDLE TRUE)
     set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/../shared/Info.plist")
 
-    set(plugin_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/PlugIns")
-    set(qtconf_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/Resources")
+    set(BUNDLE "\${CMAKE_INSTALL_PREFIX}/${COPYQ_EXECUTABLE_NAME}.app")
 
-    macro(install_qt_plugin _qt_plugin_name _qt_plugins_var)
-        get_target_property(_qt_plugin_path "${_qt_plugin_name}" LOCATION)
-        if(EXISTS "${_qt_plugin_path}")
-            get_filename_component(_qt_plugin_file "${_qt_plugin_path}" NAME)
-            get_filename_component(_qt_plugin_type "${_qt_plugin_path}" PATH)
-            get_filename_component(_qt_plugin_type "${_qt_plugin_type}" NAME)
-            set(_qt_plugin_dest "${plugin_dest_dir}/${_qt_plugin_type}")
-            install(FILES "${_qt_plugin_path}" DESTINATION "${_qt_plugin_dest}" COMPONENT Runtime)
-            set(${_qt_plugins_var}
-                "${${_qt_plugins_var}};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_qt_plugin_dest}/${_qt_plugin_file}")
-        else()
-            message(FATAL_ERROR "QT plugin ${_qt_plugin_name} not found")
-        endif()
-    endmacro()
-
-    # Install needed Qt plugins
-    foreach(_copyq_qt_module ${copyq_qt_modules} "Gui" "Widgets")
-        set(_module_plugins "${${copyq_qt}${_copyq_qt_module}_PLUGINS}")
-        foreach(_plugin ${_module_plugins})
-            install_qt_plugin("${_plugin}" FIXUP_BUNDLE_QT_PLUGINS)
-        endforeach()
-    endforeach()
-
-    # install a qt.conf file
-    # this inserts some cmake code into the install script to write the file
-    install(CODE "
-        file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${qtconf_dest_dir}/qt.conf\" \"[Paths]\nPlugins = PlugIns\nImports = Resources/qml\nQml2Imports = Resources/qml\n\")
-        "
-        COMPONENT Runtime
-        )
-
-    set(FIXUP_BUNDLE_APPS "\${CMAKE_INSTALL_PREFIX}/${COPYQ_EXECUTABLE_NAME}.app")
-
-    get_property(_copyq_installed_plugins GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)
-
-    # Directories to look for dependencies
-    set(FIXUP_BUNDLE_DEP_DIRS "${CMAKE_BINARY_DIR};${QT_LIBRARY_DIRS};${${copyq_qt}Widgets_DIR}/../..")
-
-    message(STATUS "Fixup app: ${FIXUP_BUNDLE_APPS}")
-    message(STATUS "Fixup app plugins: ${_copyq_installed_plugins}")
-    message(STATUS "Fixup qt plugins: ${FIXUP_BUNDLE_QT_PLUGINS}")
-    message(STATUS "Fixup dirs: ${FIXUP_BUNDLE_DEP_DIRS}")
-    install(CODE "
-        include(BundleUtilities)
-        set(BU_CHMOD_BUNDLE_ITEMS ON)
-        fixup_bundle(\"${FIXUP_BUNDLE_APPS}\" \"${FIXUP_BUNDLE_QT_PLUGINS};${_copyq_installed_plugins}\" \"${FIXUP_BUNDLE_DEP_DIRS}\")
-        verify_app(\"${FIXUP_BUNDLE_APPS}\")
-        "
-        COMPONENT Runtime
-        )
-
-    set(CPACK_GENERATOR "DragNDrop")
-    include(CPack)
+    # https://doc.qt.io/qt-6/qt-deploy-runtime-dependencies.html
+    # Generate a deployment script to be executed at install time
+    qt_generate_deploy_script(
+        TARGET ${COPYQ_EXECUTABLE_NAME}
+        OUTPUT_SCRIPT deploy_script
+        CONTENT "
+qt_deploy_runtime_dependencies(
+    EXECUTABLE \"${BUNDLE}\"
+    GENERATE_QT_CONF
+    VERBOSE
+)")
+    install(SCRIPT ${deploy_script})
 endif()

=== debian/changelog ===
copyq (8.0.0-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Make recommended packages explicit dependencies.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 21 Mar 2024 15:53:40 -0700

copyq (8.0.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 19 Mar 2024 21:46:57 -0400

copyq (7.1.0-2) unstable; urgency=medium

  * QA upload.
  * Orphan the package. (See #1065740)

 -- Boyuan Yang <byang@debian.org>  Sat, 09 Mar 2024 11:32:28 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: copyq
 Section: utils
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends: cmake, debhelper-compat (= 13), extra-cmake-modules
 Build-Depends-Arch: libkf5notifications-dev,
                     libqt5svg5-dev,
@@ -26,10 +25,8 @@
 
 Package: copyq
 Architecture: any
-Depends: copyq-plugins (= ${binary:Version}),
-         libqt5svg5,
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends},
+         copyq-plugins (= ${binary:Version}), libqt5svg5
 Suggests: copyq-doc
 Description: Advanced clipboard manager with editing and scripting features
  CopyQ monitors system clipboard and saves its content in customized tabs.

=== debian/rules ===
--- 
+++ 
@@ -39,6 +39,9 @@
 
 override_dh_auto_install-indep:
 
+override_dh_installchangelogs:
+	dh_installchangelogs -k CHANGES.md
+
 # No dbgsym packages:
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym

## copyq 9.0.0

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python -msphinx
SPHINXPROJ    = CopyQ
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== plugins/itemtags/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 set(copyq_plugin_itemtags_SOURCES
     ../../src/item/itemwidgetwrapper.cpp
     ../../src/item/itemsaverwrapper.cpp
+    ../../src/common/command.cpp
     ../../src/common/config.cpp
     ../../src/common/log.cpp
     ../../src/common/mimetypes.cpp

=== debian/changelog ===
copyq (9.0.0-1~bpo12+1) bookworm-backports; urgency=medium

  * QA upload.
  * Rebuild for bookworm-backports.

 -- Boyuan Yang <byang@debian.org>  Sun, 07 Jul 2024 22:02:08 -0400

copyq (9.0.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 26 Jun 2024 10:18:49 -0400

=== debian/rules ===
--- 
+++ 
@@ -41,7 +41,3 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs -k CHANGES.md
-
-# No dbgsym packages:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
